/*
 *	A GAS 386 backend for T -- Copyright (C) 1997,1998 Nils M. Holm
 *	See t.c for details.
 */

#define BPW		4	/* bytes per word */
#define PUSHDOWN	1	/* push-down stack */


p(s)
char	*s;
{
	putchar('\t');
	printf("%s", s);
}


nl() {
	putchar('\n');
}


t(s)
char	*s;
{
	printf("%s", s);
}


text() {
	p(".text"); nl();
}


data() {
	p(".data"); nl();
}


bss() {
	p(".bss"); nl();
}


lab(n) {
	printf("_L_%u", n);
}


num(n) {
	printf("%d", n);
}


push() {
	p("pushl\t%eax"); nl();
}


pop() {
	p("popl\t%eax"); nl();
}


push2() {
	p("pushl\t%ecx"); nl();
}


pop2() {
	p("popl\t%ecx"); nl();
}


extdecl(s)
char	*s;
{
}


globdecl(s, z)
char	*s;
int	z;
{
	bss();
	p(".align\t2"); nl();
	if (z) {
		p(".comm\t"); t(s); t(","); num(z*BPW); nl();
	}
	else {
		p(".comm\t"); t(s); t(","); num(BPW); nl();
	}
	text();
}


loadglob(s, a, n)
char	*s;
int	a, n;
{
	if (n)
		p("movl\t$");
	else
		p("movl\t");
	t(s); t(",%eax"); nl();
	push();
}


loadlocl(a, n) {
	if (n) {
		p("movl\t$"); num(-a*BPW);
		t(",%eax"); nl();
		p("addl\t%ebp,%eax"); nl();
	}
	else {
		p("movl\t"); num(-a*BPW); t("(%ebp),%eax"); nl();
	}
	push();
}


indirect() {
	pop();
	p("movl\t(%eax),%eax"); nl();
	push();
}


deref(lval) {
	pop2();
	pop();
	p("shll\t$2,%ecx"); nl();	/* BPW == 4 !! */
	p("addl\t%ecx,%eax"); nl();
	if (!lval) {
		p("movl\t(%eax),%eax"); nl();
	}
	push();
}


saveglob(s, a)
char	*s;
int	a;
{
	pop();
	p("movl\t%eax,"); t(s); nl();
}


savelocl(a) {
	pop();
	p("movl\t%eax,"); num(-a*BPW); t("(%ebp)"); nl();
}


storevec() {
	pop2();
	pop();
	p("movl\t%ecx,(%eax)"); nl();
}


stack(n) {
	if (n) {
		p("subl\t$"); num(n*BPW); t(",%esp"); nl();
	}
}


unstack(n) {
	if (n) {
		p("addl\t$"); num(n*BPW); t(",%esp"); nl();
	}
}


call(s, n)
char	*s;
int	n;
{
	p("call\t"); t(s); nl();
	unstack(n);
	push();
}


numlit(n) {
	p("movl\t$"); num(n);
	t(",%eax"); nl();
	push();
}


strlit(s)
char	*s;
{
	int	i, l, k = strlen(s);

	data();
	lab(l = newlab());
	t(":\t.long\t");
	for (i=0; i<k; i++) {
		if (i && !(i%10)) {
			nl();
			p(".long\t");
		}
		printf("%d", s[i]);
		if (i%10!=9) putchar(',');
	}
	if (i && !(i%10)) putchar(',');
	t("0"); nl();
	text();
	return(l);
}


loadlab(l) {
	p("movl\t$"); lab(l); t(",%eax"); nl();
	push();
}


sveclit() {
	int	v;
	data();
	lab(v = newlab());
	t(":");
	return(v);
}


vecmem(n, f) {
	if (f)  {
		p(".long\t"); lab(n); nl();
	}
	else {
		p(".long\t"); num(n); nl();
	}
}


eveclit() {
	text();
}


negate() {
	pop();
	p("negl\t%eax"); nl();
	push();
}


lognot() {
	pop();
	p("negl\t%eax"); nl();
	p("sbbl\t%eax,%eax"); nl();
	p("notl\t%eax"); nl();
	push();
}


binnot() {
	pop();
	p("notl\t%eax"); nl();
	push();
}


op2(s) {
	pop2();
	pop();
	p(s); t("\t%ecx,%eax"); nl();
	push();
}


multiply() {
	pop2();
	pop();
	p("imull\t%ecx"); nl();
	push();
}


divide() {
	pop2();
	pop();
	p("cdq"); nl();
	p("idivl\t%ecx"); nl();
	push();
}


modulo() {
	pop2();
	pop();
	p("cdq"); nl();
	p("idivl\t%ecx"); nl();
	p("pushl\t%edx"); nl();
}


add() {
	op2("addl");
}


subtract() {
	op2("subl");
}



binand() {
	op2("andl");
}


binor() {
	op2("orl");
}


binxor() {
	op2("xorl");
}


binshl() {
	pop2();
	pop();
	t("shll\t%cl,%eax"); nl();
	push();
}


binshr() {
	pop2();
	pop();
	t("shrl\t%cl,%eax"); nl();
	push();
}


relop(rel) {
	int	y = newlab(), n = newlab();

	pop2();
	pop();
	p("cmpl\t%ecx,%eax"); nl();
	if (rel == '<')
		p("jl");
	else if (rel == '>')
		p("jg");
	else if (rel == 'L')
		p("jle");
	else if (rel == 'G')
		p("jge");
	else if (rel == '=')
		p("je");
	else if (rel == '#')
		p("jne");
	else
		fatal("bad relation in relop()", NULL);
	p(""); lab(y); nl();
	p("xorl\t%eax,%eax"); nl();
	p("jmp\t"); lab(n); nl();
	lab(y); t(":\tmovl\t$1,%eax"); nl();
	lab(n); t(":"); nl();
	push();
}


equ() { relop('='); }
nequ() { relop('#'); }
less() { relop('<'); }
grtr() { relop('>'); }
lteq() { relop('L'); }
gteq() { relop('G'); }


incrglob(s, a, v)
char	*s;
int	a, v;
{
	p("addl\t$"); num(v); t(","); t(s); nl();
}


incrlocl(a, v) {
	p("addl\t$"); num(v); t(","); num(-a*BPW); t("(%ebp)"); nl();
}


tcond(n, flags) {
	int	l = newlab();

	pop();
	p("orl\t%eax,%eax"); nl();
	if (flags)
		p(flags==1? "je\t": "jne\t");
	else
		p("jne\t");
 	lab(l); nl();
	if (flags) push();
	p("jmp\t"); lab(n); nl();
	lab(l); t(":"); nl();
}


fcond(y, n) {
	p("jmp\t"); lab(y); nl();
	lab(n); t(":"); nl();
}


econd(y) {
	lab(y); t(":"); nl();
}


forcond(step, e) {
	int	l = newlab();

	pop2();
	pop();
	p("cmpl\t%ecx,%eax"); nl();
	p(step>0? "jl\t": "jg\t"); lab(l); nl();
	p("jmp\t"); lab(e); nl();
	lab(l); t(":"); nl();
}


jump(l) {
	p("jmp\t"); lab(l); nl();
}


mark(l) {
	lab(l); t(":"); nl();
}


fnhdr(s, l)
char	*s;
int	l;
{
	t(s); t(":"); nl();
	lab(l); t(":"); nl();
	p("pushl\t%ebp"); nl();
	p("movl\t%esp,%ebp"); nl();
}


fnexit(r) {
	lab(r); t(":");
	p("popl\t%ebp"); nl();
	p("ret"); nl();
}


genhalt() {
	p("pushl\t$0"); nl();
	p("call\t__exit"); nl();
}


prologue() {
	t("/*"); nl();
	t(" *  Compiled by T 3r0c -- Copyright (C) 1997,1998 Nils M. Holm");
	nl();
	t(" *  Code generated for GAS(i386)"); nl();
	t(" */"); nl();
	text();
	p("call\t_LIBINIT"); nl();
	p("jmp\tSTART"); nl();
}


start() {
	t("START:");
	p("movl\t%esp,%ebp"); nl();
}


epilogue() {
	genhalt();
}

