/*
 *	Runtime support routines for T 3.
 *	Copyright (C) 1997 Nils M. Holm.
 *	See t.t for details.
 */

#define BPW	4
#define BUFLEN	1024
#define STRLEN	256


int	Input, Output;
char	NL[3];


LIBINIT() {
	Input = 0;
	Output = 1;
#ifdef msdos
	NL[0] = '\r';
	NL[1] = '\n';
	NL[2] = 0;
#else
	NL[0] = '\n';
	NL[1] = 0;
#endif
}


#ifndef msdos
pack_(s, v)
unsigned char	*s;
unsigned int	*v;
{
	int	i;

	for (i=0; v[i]; i++) s[i] = v[i];
	s[i] = 0;
	return((i+BPW)/BPW);
}


unpack_(v, s)
unsigned int	*v;
unsigned char	*s;
{
	int	i;

	for (i=0; s[i]; i++) v[i] = s[i];
	v[i] = 0;
	return(i);
}


length(v)
int	*v;
{
	int	i = 0;

	while (v[i]) i++;
	return(i);
}
#endif


aton_(s)
int	*s;
{
	int	k, v = 0, g = 0;

	k = 0;
	while (	s[k] == ' ' || s[k] == '\t' || s[k] == '\n' ||
		s[k] == '\r' || s[k] == '\f'
	)
		k++;
	if (s[k] == '-' || s[k] == '%') {
		g = 1;
		k++;
	}
	else if (s[k] == '+') {
		k++;
	}
	while ('0' <= s[k] && s[k] <= '9') {
		v = v*10 + (s[k]-'0');
		k++;
	}
	return(g? -v: v);
}


int *ntoa_(w, v) {
	static int	n[STRLEN+1];
	int		i, g = 0;
	unsigned	u;

	if (v<0) {
		g = 1;
		v = -v;
	}
	u = v;
	n[STRLEN] = 0;
	i = STRLEN-1;
	while (u || i == STRLEN-1) {
		n[i--] = u%10+'0';
		u = u/10;
		w--;
	}
	if (g) {
		n[i--] = '-';
		w--;
	}
	while (w>0) {
		n[i--] = ' ';
		w--;
	}
	return(n+i+1);
}


open_(mode, file)
int	*file, mode;
{
	char	name[256];
	int	fd;

	pack_(name, file);
	if (mode == 1)
		fd = creat(name, 0666);
	else if (mode == 0 || mode == 2 || mode == 3)
		fd = open(name, mode==3? 2: mode);
	else
		return(-1);
	if (fd> 0 && mode == 3) lseek(fd, 0L, 2);
	return(fd);
}


close_(fd) {
	return(close(fd));
}


erase_(file)
int	*file;
{
	char	name[256];

	pack_(name, file);
	return(unlink(name));
}


select_(new, port) {
	int	old;

	if (port) {
		old = Output;
		Output = new;
	}
	else {
		old = Input;
		Input = new;
	}
	return(old);
}


reads_(n, s)
int		n;
unsigned int	*s;
{
	unsigned char	IOBuf[BUFLEN+1];
	int		k, i;

	k = read(Input, IOBuf, n);
	if (k<0) return(k);
	for (i=0; i<k; i++) s[i] = IOBuf[i] & 255;
	s[i] = 0;
	return(k);
}


writes_(s)
int	*s;
{
	char	IOBuf[BUFLEN+1];

	pack_(IOBuf, s);
	return(write(Output, IOBuf, length(s)));
}


newline_() {
#ifdef msdos
	write(Output, NL, 2);
#else
	write(Output, NL, 1);
#endif
}

